// Generated by CoffeeScript 1.7.1

/* Copyright Information
	 * @author	Maximilian Mader
	 * @copyright	2010-2014 Tim Düsterhus
	 * @license	Creative Commons Attribution-NonCommercial-ShareAlike <http://creativecommons.org/licenses/by-nc-sa/3.0/legalcode>
	 * @package	be.bastelstu.chat
 */

(function() {
  (function($, window) {
    "use strict";
    var Log, init, _base, _base1, _base2, _hasContent, _loadContent, _messageLogContent, _proxy, _success;
    _messageLogContent = null;
    _hasContent = {};
    _proxy = null;
    init = function() {
      var activeMenuItem, enableProxy;
      _messageLogContent = $('#messageLogContent');
      activeMenuItem = _messageLogContent.data('active');
      enableProxy = false;
      _messageLogContent.find('div.tabMenuContent > .subTabMenuContent').each(function(index, container) {
        var containerID;
        containerID = $(container).wcfIdentify();
        if (!$("#" + containerID).hasClass('empty')) {
          return _hasContent[containerID] = true;
        } else {
          _hasContent[containerID] = false;
          return enableProxy = true;
        }
      });
      if (enableProxy) {
        _proxy = new WCF.Action.Proxy({
          success: _success
        }, _messageLogContent.bind('wcftabsbeforeactivate', _loadContent));
      }
      if (!_hasContent[activeMenuItem]) {
        return _loadContent({}, {
          newPanel: $("#" + activeMenuItem),
          newTab: $("#" + activeMenuItem).parent().find(".menu > ul > li").first()
        });
      }
    };
    _loadContent = function(event, ui) {
      var containerID, start, tab;
      containerID = $(ui.newPanel).attr('id');
      if ($("#" + ($(ui.newPanel).attr('id'))).hasClass('tabMenuContainer')) {
        containerID = $("#" + containerID + " > .subTabMenuContent").first().attr('id');
        tab = $("#" + containerID).parent().find(".menu > ul > li").first();
      } else {
        tab = $(ui.newTab);
      }
      if (!_hasContent[containerID]) {
        start = _messageLogContent.data('baseTime') + (tab.data('hour') * 3600) + (tab.data('minutes') * 60);
        _proxy.setOption('data', {
          actionName: 'getMessages',
          className: 'chat\\data\\message\\MessageAction',
          parameters: {
            containerID: containerID,
            start: start,
            end: start + 1799,
            roomID: _messageLogContent.data('roomID')
          }
        });
        return _proxy.sendRequest();
      }
    };
    _success = function(data, textStatus, jqWHR) {
      var containerID, content;
      containerID = data.returnValues.containerID;
      _hasContent[containerID] = true;
      content = _messageLogContent.find("#" + containerID);
      if (data.returnValues.template !== '') {
        $("<div>" + data.returnValues.template + "</div>").hide().appendTo(content);
        if (!data.returnValues.noMessages) {
          content.addClass('tabularBox');
        }
      }
      return content.children().first().show();
    };
    Log = {
      TabMenu: {
        init: init
      }
    };
    if (window.be == null) {
      window.be = {};
    }
    if (be.bastelstu == null) {
      be.bastelstu = {};
    }
    if ((_base = be.bastelstu).Chat == null) {
      _base.Chat = {};
    }
    if ((_base1 = be.bastelstu.Chat).ACP == null) {
      _base1.ACP = {};
    }
    if ((_base2 = be.bastelstu.Chat.ACP).Log == null) {
      _base2.Log = {};
    }
    return window.be.bastelstu.Chat.ACP.Log = Log;
  })(jQuery, this);

}).call(this);
